<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN"
  "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="de" lang="de">
	<head>
		<title>Semantischer, aufklappbarer Verzeichnisbaum</title>
		<meta http-equiv="content-type" content="text/html; charset=utf-8" />
		<link type="text/css" rel="stylesheet" href="css/screen.css" />
		<script type="text/javascript" src="http://ajax.googleapis.com/ajax/libs/jquery/1.4.2/jquery.min.js"></script>
		<script type="text/javascript">
			$('html').addClass('js');
		</script>
		<script type="text/javascript" src="js/functions.js"></script>
	</head>
	<body>
<?php
	function fileinfo ($path) {
		// simple replacement for
		// http://php.net/manual/en/ref.fileinfo.php

		if($mime_type = @getimagesize($path)) {
			$mime_type = $mime_type['mime'];
		} else {
			$basename = basename($path);
			if (strpos($basename, '.') !== false) { 
				$ext = end(explode('.', $path));
				switch ($ext) {
					case 'css':
						$mime_type = 'text/css';
						break;
					case 'html':
					case 'htm':
						$mime_type = 'text/html';
						break;
					case 'js':
						$mime_type = 'text/javascript';
						break;
					case 'php':
					case 'php3':
					case 'php4':
					case 'php5':
					case 'php6':
					case 'phpsh':
					case 'phtml':
						$mime_type = 'application/x-httpd-php';
						break;
					case 'txt':
						$mime_type = 'text/plain';
						break;
					case 'gz':
						$mime_type = 'application/x-gzip';
						break;
				}
			}
		}
		return $mime_type;
	}

	function get_tree($dir = './') {
		$tree['dir'] = array();
		$tree['file'] = array();
		
		$handle = @opendir($dir);
		while(($file = @readdir($handle)) !== false) {
			if ($file != '.' && $file != '..') {
				$dir = preg_replace('/^(.*)\/+$/', '$1', $dir);

				$name = $file;
				$path = $dir . '/' . $file;

				if (is_dir($path)) {
					$tree['dir'][] = array(
						'name' => $name,
						'type' => 'dir',
						'path' => $path,
						'data' => get_tree($path)
					); 
					
				} else if (is_file($path)) {
					$tree['file'][] = array(
						'name' => $name,
						'type' => fileinfo($path),
						'path' => $path
					); 
				}
			}
		}
		
		sort($tree['dir']);
		sort($tree['file']);
		return array_merge($tree['dir'], $tree['file']);
	}

	function build_dir($tree, $main = false) {
		if (is_array($tree) && count($tree) > 0) {
			foreach ($tree as $item) {
				if ($item['type'] == 'dir') {
					$list .= '<li><span>'. $item['name'] . '</span>' . ((count($item['data']) > 0) ? build_dir($item['data']) : '') . '</li>';
				} else {
					$list .= '<li><a' . ((!empty($item['type'])) ? ' type="' . $item['type'] . '" ' : ' ') . 'href="' . $item['path'] . '">'. $item['name'] . '</a></li>';
				}
				
			}
		}
		$list = '<ul>' . $list . '</ul>';
	 
		if($main) {
			return '<div class="directory"><h2>/ (root)</h2>' . $list . '</div>';
		} else {
			return $list;
		}
	}

	echo build_dir(get_tree('./', true), true);
?>
	</body>
</html>